
------------------------------- Sample user tables ------------------------------- 

DROP TABLE customer;

CREATE TABLE customer 
(
	pkey		VARCHAR2(10) NOT NULL	PRIMARY KEY,
	fname		VARCHAR2(20),
	lname		VARCHAR2(20),
	ccode		VARCHAR2(10)
);


DROP TABLE address;

CREATE TABLE address 
(
	addrid		VARCHAR2(10) NOT NULL	PRIMARY KEY,
	custid		VARCHAR2(10),
	city			VARCHAR2(20),
	zipcode	VARCHAR2(10),
	FOREIGN KEY(custid) REFERENCES customer(pkey)
);


DROP TABLE custinfo;

CREATE TABLE custinfo 
(
	ccode		VARCHAR2(10) NOT NULL	PRIMARY KEY,
	cdata		VARCHAR2(10)
);




------------------------------------- Event table -------------------------------------


DROP TABLE wbia_jdbc_eventstore;

CREATE TABLE wbia_jdbc_eventstore
(
	event_id					NUMBER(20)	PRIMARY KEY,
	xid			VARCHAR2(200),
	object_key				VARCHAR2(80)	NOT NULL,
	object_name		VARCHAR2(40)	NOT NULL,
	object_function		VARCHAR2(40)	NOT NULL,
	event_priority	    NUMBER(5)	NOT NULL,
	event_time			DATE	DEFAULT SYSDATE NOT NULL,			
	event_status			NUMBER(5)	NOT NULL,
	connector_ID            VARCHAR2(40),
	event_comment	VARCHAR2(100)
); 

CREATE SEQUENCE event_sequence start with 1;



------------------------------------- Triggers for customer table -------------------------------------


DROP TRIGGER EVENT_CREATE;
DROP TRIGGER EVENT_UPDATE;
DROP TRIGGER EVENT_DELETE;


CREATE OR REPLACE TRIGGER event_create
AFTER INSERT ON CUSTOMER
FOR EACH ROW
BEGIN
INSERT INTO
wbia_jdbc_eventstore (event_id, object_key, object_name, object_function, event_priority, event_status,connector_ID)
VALUES(event_sequence.nextval, :NEW.pkey, 'SchemaNameCustomerBG', 'Create', 1, 0,'001');
END;


CREATE OR REPLACE TRIGGER event_update
AFTER UPDATE ON CUSTOMER
FOR EACH ROW
BEGIN
INSERT INTO
wbia_jdbc_eventstore (event_id, object_key, object_name, object_function, event_priority, event_status,connector_ID)
VALUES(event_sequence.nextval, :NEW.pkey, 'SchemaNameCustomerBG', 'Update', 1, 0,'001');
END;


CREATE OR REPLACE TRIGGER event_delete
AFTER DELETE ON CUSTOMER
FOR EACH ROW
BEGIN
INSERT INTO
wbia_jdbc_eventstore (event_id, object_key, object_name, object_function, event_priority, event_status,connector_ID)
VALUES(event_sequence.nextval, :OLD.pkey, 'SchemaNameCustomerBG', 'Delete', 1, 0,'001');
END;



